class BackaidGenerator < Rails::Generators::Base #NamedBase means name is required argument for generator
  # look inside template dir for any additional files
  source_root File.expand_path('../templates', __FILE__)

  # all public methods inside generator file execute when generator run
  # def gen_backbone_dir_structure
  #   puts "Holla at your directories: models, collections, templates, views, routers"
    
  #   Dir.mkdir("app/assets/javascripts/backbone")
  #   ["models", "collections", "views", "routers", "templates"].each do |dir|
  #     Dir.mkdir("app/assets/javascripts/backbone/#{dir}")
  #   end
  # end

  %w{models collections views routers templates}.each do |dir|
    empty_directory "app/assets/javascripts/backbone/#{dir}"
  end

  # def require_backbone
  #   append_specific 'app/assets/javascripts/application.js' do |line|
  #     line = line == "//= require_tree .\n" ? "//= require underscore\n//= require backbone\n//= require_tree ./backbone/models\n//= require_tree ./backbone/collections\n//= require_tree ./backbone/templates\n//= require_tree ./backbone/views\n//= require_tree ./backbone/routers" : line
  #   end

  #   append_specific 'app/views/layouts/application.html.erb' do |line|
  #     line = line == "<%= yield %>\n" ? line + "\n<%= javascript_include_tag 'application' %>" : line
  #   end
  # end

  # require depedencies in manifest file
  insert_into_file 'app/assets/javascripts/application.js', "//= require underscore\n//= require backbone\n//= require_tree ./backbone/models\n//= require_tree ./backbone/collections\n//= require_tree ./backbone/templates\n//= require_tree ./backbone/views\n//= require_tree ./backbone/routers", :after => "//= require_tree .\n"
  # require in html file
  insert_into_file 'app/views/layouts/application.html.erb', "\n<%= javascript_include_tag 'application' %>", :after => "<%= yield %>\n"
  # remove extra include incude tag in layout html
  insert_into_file 'app/views/layouts/application.html.erb', "", :after => "<%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>"

  
  puts "Holla at your directories: models, collections, templates, views, routers"
  # private

  # def append_specific(path)
  #   lines = IO.readlines(path).map do |line|
  #     yield line
  #   end

  #   File.open(path, 'w') do |file|
  #     file.puts lines
  #   end
  # end
end
